//Core class body

#include"core.h"

void Core::init(){
	SDL_Init(SDL_INIT_VIDEO);
	gWindow = SDL_CreateWindow("Platform Test!",SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED,SCREEN_WIDTH,SCREEN_HEIGHT,SDL_WINDOW_SHOWN);
	gRenderer = SDL_CreateRenderer(gWindow,-1,SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC);
	SDL_SetRenderDrawColor(gRenderer,0xFF,0xFF,0xFF,0xFF);
	
	sz = SCREEN_WIDTH/16;
}

void Core::close(){
	SDL_DestroyRenderer(gRenderer);
	SDL_DestroyWindow(gWindow);
	gWindow = NULL;
	gRenderer = NULL;

	SDL_Quit();
}

int Core::coreInit(){
	init();

	bool quit = false;
	SDL_Event e;


	Player posweg(&gRenderer);
	
	Powerup powerup(13*sz,SCREEN_HEIGHT-sz*4,&gRenderer,&posweg);

	while(!quit){
		while(SDL_PollEvent(&e)!=0){
			if(e.type == SDL_QUIT){
				quit = true;
			}
		}

		Camera camera(36*sz,SCREEN_WIDTH);
		
		SDL_SetRenderDrawColor(gRenderer,0,0,100,0xFF);
		SDL_RenderClear(gRenderer);

		posweg.print(100,100,camera.getPosX());
		
		Block wallA(8*sz,7*sz,sz*2,sz*2,&gRenderer,&posweg,camera.getPosX());
		Block wallB(4*sz,9*sz,sz,sz*2,&gRenderer,&posweg,camera.getPosX());
		Block wallC(6*sz,9*sz,sz,sz*2,&gRenderer,&posweg,camera.getPosX());
		Block ground(0,11*sz,16*sz,sz,&gRenderer,&posweg,camera.getPosX());
		Block ground2(sz*20,sz*11,sz*16,sz,&gRenderer,&posweg,camera.getPosX());

		camera.update(posweg.getRectangle().x,posweg.getRectangle().y);

		SDL_RenderPresent(gRenderer);
	}
	close();
	return 0;
};

